function [error,xinit,par,xnext,ts,xs] = cyclicWalkError(x0,par,targetStepLen,targetVelocity,initLegAngle)
% cyclicWalkError(x0,par,targetStepLen,targetTime,initLegAngle)
%
% Computes the variation from a cyclic walk.
% Finding the zeros of this function is equivalent to finding a periodic gait.

    targetTime = targetStepLen/targetVelocity;

    xinit = [initLegAngle;-initLegAngle;x0(1:2)];
    par.k = abs(x0(3));
    par.imp = abs(x0(4));
    [xnext,tcont,ts,xs] = simulateAWalker([0,1.05*targetTime],xinit,par,[]);
    diff = xnext - xinit;
%     error = [diff; stepLengthError(xnext(1),targetStepLen,par); tcont - targetTime];
    error = [diff(3:4); stepLengthError(xnext(1),targetStepLen,par); (tcont - targetTime)/targetTime];
end
