function [xsoln, error, initLegAngle] = findWalkParameters(par,targetStepLen,targetVelocity,x0,initLegAngle)
% [xsoln, error, initLegAngle] = findWalkParameters(par,targetStepLen,targetVelocity,x0,initLegAngle)
%
% Uses fsolve to try to find the fixed points of cyclicWalkError.
    if nargin < 5 || isempty(initLegAngle)
        initLegAngle = fzero(@(legang) stepLengthError(legang,targetStepLen,par),pi/4);
    end

    x0 = reshape(squeeze(x0),[4 1]);
    
    opts = optimset('MaxFunEvals',10000,'MaxIter',10000);
    [xsoln, error] = fsolve(@(x) cyclicWalkError(x,par,targetStepLen,targetVelocity,initLegAngle),x0,opts);
    xsoln(3:4) = abs(xsoln(3:4));
end


