function R = subsref(this,S)
    if length(S) ~= 1
        error('Multiple subreferences not allowed.');
    end

    if strcmp(S(1).type,'()')
        subs = S(1).subs;
        Rsz = zeros([1,length(subs)]);
        Rinds = cell([length(subs),1]);
        totalNumInds = 1;
        for i = 1:length(subs)
            if ischar(subs{i}) && strcmp(subs{i},':')
                if i <= length(this.sz)
                    if i == length(subs)
                        sInds = 1:prod(this.sz(i:end));
                    else
                        sInds = 1:this.sz(i);
                    end
                else
                    sInds = 1;
                end
            else
                sInds = subs{i};
            end
            sInds = reshape(sInds,[],1);
            Rsz(i) = length(sInds);
            
            for j = 1:(i-1)
                Rinds{j} = repmat(Rinds{j},[Rsz(i),1]);
            end
            Rinds{i} = reshape(repmat(sInds.',[totalNumInds,1]),[],1);
            totalNumInds = totalNumInds*Rsz(i);
        end
        Rinds = sub2ind(this.sz,Rinds{:});
        nzInds = this.nzMat(Rinds);
        RnzInds = find(nzInds ~= 0);
        if max(RnzInds) == totalNumInds
            R(RnzInds) = this.symValues(nzInds(RnzInds));
        else
            R([reshape(RnzInds,1,[]) totalNumInds]) = [reshape(this.symValues(nzInds(RnzInds)),1,[]) sym(0)];
        end
        if isscalar(Rsz)
            R = reshape(R,[Rsz 1]);
        else
            R = reshape(R,Rsz);
        end
    else
        error('Reference type currently not supported.');
    end

end
