function [Mc, Ic, CoMc] = combineParts(M1,I1,CoM1,R1,M2,I2,CoM2,R2)
% Combine the mass description of two parts into a single rigid part.
%
% Each part is related to a global coordinate from by the location of its center
% of mass (CoM) and the rotation from the local frame to the global frame (R).
% The resulting ineratia matrix is centered around the combined center of
% mass (CoMc).
    Mc = M1 + M2;
    CoMc = (M1*CoM1 + M2*CoM2)/Mc;
    Ic = transformInertiaMatrix(I1,M1,R1,CoM1-CoMc) + transformInertiaMatrix(I2,M2,R2,CoM2-CoMc);
end
