function writeProjFunc(funcname,eom)
    q = eom.q;
    qd = eom.qd;

    qDims = length(q);

    fid = fopen([funcname '.m'],'wt');
    fprintf(fid,'function x = %s(x)\n',funcname);

    fprintf(fid,'\t%% extract the state variables\n');
    fprintf(fid,'\tq = x(1:%d);\n',qDims);
    fprintf(fid,'\tqd = x(%d:end);\n',qDims+1);
    for i = 1:qDims
        fprintf(fid,'\t%s = q(%d);\n',char(q(i)),i);
    end
    for i = 1:qDims
        fprintf(fid,'\t%s = qd(%d);\n',char(qd(i)),i);
    end

    fprintf(fid,'\n\t%% project the state variables\n');
    for i = 1:qDims
        fprintf(fid,'\tx(%d) = %s;\n', i, char(eom.proj(i)));
        fprintf(fid,'\tx(%d) = %s;\n', i+qDims, char(eom.proj(i+qDims)));
    end
    fclose(fid);
end
