function ydot = constrainedPointMassODE(t,y,mass,force)
    p = y(1:2);
    v = y(3:4);

    constraint = p.'*p - 1;
    dconstraintdp = 2*p;
    dconstraintdt = 2*p.'*v;
    d2constraintdtdp = 2*v;

    LHS = [mass*eye(2) dconstraintdp; dconstraintdp.' 0];
    RHS = [force;-d2constraintdtdp.'*v];
    soln = LHS\RHS;

    ydot = [v; soln(1:2)];
end