function ydot = rigidBodyODE(t,y,opts)
    mass = opts.mass;
    inertia = opts.inertia;
    force = opts.force;
    bodyTorque = opts.bodyTorque;
    worldTorque = opts.worldTorque;

    c = y(1:3);
    q = y(4:7);
    v = y(8:10);
    bodyOmega = y(11:13);
    
    netBodyTorque = bodyTorque + quatrot(quatconj(q),worldTorque);

    ydot = [                                                            v; ...
                                            0.5*quatmult(q,[0;bodyOmega]); ...
                                                               force/mass; ...
             inertia\(netBodyTorque - cross(bodyOmega,inertia*bodyOmega)); ];
end
    