function angs = quat2angles(q)
    R = quatrot(q);
    
    abs_sb = sqrt(R(1, 3) * R(1, 3) + R(2, 3) * R(2, 3));
    if (abs_sb > 16*eps)
        gamma = atan2(R(2, 3), -R(1, 3));
        alpha = atan2(R(3, 2),  R(3, 1));
        if (abs(sin(gamma)) < eps)
            sign_sb = sign(-R(1, 3) / cos(gamma));
        elseif sin(gamma) > 0
            sign_sb = sign(R(2,3));
        else
            sign_sb = -sign(R(2,3));
        end
        beta  = atan2(sign_sb * abs_sb, R(3, 3));
    else
        if (R(3, 3) > 0)
            alpha = 0;
            beta  = 0;
            gamma = atan2(-R(2, 1), R(1, 1));
        else
            alpha = 0;
            beta  = pi;
            gamma = atan2(R(2, 1), -R(1, 1));
        end
    end
    
    angs(1) = alpha;
    angs(2) = beta;
    angs(3) = gamma;
end
